function [] = accAnalysis(myfilename)
[pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename);


acc_sum = acc_combined(:,1)+acc_combined(:,2)+acc_combined(:,3);

sample_start = 16000;
sample_end = 21000;

% plot the selection we want to analyze in the time domain
figure;
plot(accTime(sample_start:sample_end),acc_sum(sample_start:sample_end));

Fs = 3000;                    % Sampling frequency
L = sample_end-sample_start;                     % Length of signal
NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(acc_sum(sample_start:sample_end),NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2);

figure;
% Plot single-sided amplitude spectrum.
plot(f,2*abs(Y(1:NFFT/2))) 
title('Single-Sided Amplitude Spectrum of acc_sum(t)')
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')