function [ acc_vect ] = accThreshVector(acc_combined, accThreshold, auto_threshold)

% amount of data to use for auto threshodling
threshold_samples = 3000;   % 300 samples == .1 second for 3khz sample rate acc data

% create our blank new vector
acc_vect = zeros(size(acc_combined));

% check if we want auto_thresholding
if(auto_threshold)
   for j=1:length(acc_combined(1,:))
       threshold(j) = max(acc_combined(1:threshold_samples,j))- min(acc_combined(1:threshold_samples,j));
   end    
% if not auto_threshold use accThreshold for each axis
else
   for j=1:length(acc_combined(1,:))
       threshold(j) = accThreshold;
   end
end

% walk through and threshold the differences between values
for j=1:length(acc_combined(1,:))
    acc_vect(1,j) = acc_combined(1,j);
    for i=2:length(acc_combined(:,j))
        if(abs(acc_combined(i,j)) > abs(acc_combined(i-1,j))-threshold(j) && abs(acc_combined(i,j)) < abs(acc_combined(i-1,j))+threshold(j)) 
            acc_vect(i,j) = acc_vect(i-1,j);
        else
            acc_vect(i,j) = acc_combined(i,j);
        end
    end
end




