function [acc_combined accTime] = create3khzAcc(time, data)

j = 1;      % temporary index variable to construct our new accelration vector

% reconstruct our 3khz 3-axis acceleration from the 3 1-khz vectors by
% placing their data into a new vector, for example:
% acc_combined(:,1) = [ aX0(1) aX1(1) aX2(1) aX0(2) aX1(2) aX2(2) aX0(3) ...]
% our new matrix has the data in rows and the axes in columns
for i=1:length(data.aX0)
    acc_combined(j,1) = data.aX0(i);   
    acc_combined(j+1,1) = data.aX1(i);
    acc_combined(j+2,1) = data.aX2(i);
    
    acc_combined(j,2) = data.aY0(i);   
    acc_combined(j+1,2) = data.aY1(i);
    acc_combined(j+2,2) = data.aY2(i);
    
    acc_combined(j,3) = data.aZ0(i);   
    acc_combined(j+1,3) = data.aZ1(i);
    acc_combined(j+2,3) = data.aZ2(i);
    
    j = j+3;
end



% create an approriate time vector assuming a 3khZ rate
accTime = 0:1:length(acc_combined(:,1))-1;
accTime = accTime * 1/3000;
