function [ x y ] = getMatrixCOM(matrix)
% method to take in a 2d matrix and calculate its center of mass. method
% REQUIRES that the rows and columns are odd numbers and ASSUMES the spacing is equal in all directions
%
% cordinates output are in the following geometry:
% equally spaced grid cells
% | -x,-y   ...... +x,-y |
% | ...................  |
% | .........0 ........  |
% | ...................  |
% | -x,+y   ...... +x,+y |
%
% wikipedia centroid of mass algorithms for details


% construct our multiplication vector to get the y-center
for i= -(length(matrix(:,1))-1)/2:1:(length(matrix(:,1))-1)/2
    y_vect( i+ ((length(matrix(:,1))-1)/2) + 1 ) = i;
end


% construct our multiplication vector to get the y-center
for i= -(length(matrix(1,:))-1)/2:1:(length(matrix(1,:))-1)/2
    x_vect( i+ ((length(matrix(1,:))-1)/2) + 1 ) = i;
end

y = sum(y_vect*matrix)/sum(sum(matrix));
x = sum(matrix*x_vect')/sum(sum(matrix));