%{
*********************************************************************
 *
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *  \author Joe Romano
 *********************************************************************/
%}
%
%  @author Joe Romano
%  @brief Method to load the acceleration data from the
%  slipgrip_controller software
%
function [acc_combined accTime] = loadAccelerationRTP(myfilename)


% load our data csv file into 'data'
[time, data] = rtpload(myfilename); 

[acc_combined accTime] = create3khzAcc2(time,data); 

% reconstruct our 3khz acceleration data
%[acc_combined_raw accTime] = create3khzAcc(time,data); 

% temporarily replace the above vectors with the results from our not f'd
% up script
%[acc_combined_raw accTime] = getAccNotFdUp(time,data);

% auto-threshold then high pass filter the data at 30 hz
%[acc_combined] = hpAccelerationMatrix(acc_combined_raw,3000,60);
%[acc_combined] = accThreshVector(acc_combined_filt,0.03,true);
%figure; plot(acc_combined); figure;
%acc_combined = acc_combined_thresh;

% make a matrix of our pressure sensor data and do some post-processing
%[ pressure_left pressure_right pressureTime] = createPressureMatrix(time,data); 
%[pressure_left_hp pressure_right_hp] = hpPressureMatrix(pressure_left, pressure_right);

