function [ pressure_vect, threshold ] = pressureThreshVector(pressure_combined, pressureThreshold, auto_threshold)

% amount of data to use for auto threshodling
threshold_samples = 25;   % 25 samples == 1 second for 41 ms samples pressure data

% create our blank new vector
pressure_vect = zeros(size(pressure_combined));

% check if we want auto_thresholding
if(auto_threshold)
   for j=1:length(pressure_combined(1,:))
       threshold(j) = max(pressure_combined(1:threshold_samples,j))- min(pressure_combined(1:threshold_samples,j));
   end    
% if not auto_threshold use pressureThreshold for each axis
else
   for j=1:length(pressure_combined(1,:))
       threshold(j) = pressureThreshold;
   end
end

% walk through and threshold the differences between values
for j=1:length(pressure_combined(1,:))
    pressure_vect(1,j) = pressure_combined(1,j);
    for i=2:length(pressure_combined(:,j))
        if(abs(pressure_combined(i,j)) > abs(pressure_combined(i-1,j))-threshold(j) && abs(pressure_combined(i,j)) < abs(pressure_combined(i-1,j))+threshold(j)) 
            pressure_vect(i,j) = pressure_vect(i-1,j);
        else
            pressure_vect(i,j) = pressure_combined(i,j);
        end
    end
end



