function [] = showOpticalFlow(myfilename)
[pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename);


UNITS_PER_N = 1600;

% subsample the pressure like the robot software would
[pRaw_left_sub pRawTime_sub] = subsamplePressureVector(pRaw_left, pRawTime);
[pRaw_right_sub pRawTime_sub] = subsamplePressureVector(pRaw_right, pRawTime);
[pFilt_left_sub pFiltTime_sub] = subsamplePressureVector(pFilt_left, pFiltTime);
[pFilt_right_sub pFiltTime_sub] = subsamplePressureVector(pFilt_right, pFiltTime);

% convert to Newtons
pFilt_left_sub = pFilt_left_sub/UNITS_PER_N;
pFilt_right_sub = pFilt_right_sub/UNITS_PER_N;
pRaw_right_sub = pRaw_right_sub/UNITS_PER_N;
pRaw_left_sub = pRaw_left_sub/UNITS_PER_N;


% start our time vectors from 0
toffset = pRawTime_sub(1);
pRawTime_sub = pRawTime_sub - toffset;
pFiltTime_sub = pFiltTime_sub - toffset;
accTime = accTime - toffset;
joint_time = joint_time - toffset;
tstart = pRawTime_sub(1);
tend = pRawTime_sub(end);

%reshape our pressure vectors to the right format for our optical flow
%algorithm
for i=1:length(pFilt_right_sub) 
    pFilt_right_sub_matrix(:,:,i) = reshape(pFilt_right_sub(i,8:22),3,5);
end

for i=1:length(pFilt_left_sub) 
    pFilt_left_sub_matrix(:,:,i) = reshape(pFilt_left_sub(i,8:22),3,5);
end


for i=1:10:length(pFilt_right_sub)
    [vx_l, vy_l] = OpticalFlow(pFilt_left_sub_matrix(:,:,i:i+10), 0.1, 15);
    i
    quiver(vx_l,vy_l);
    pause(0.2);
    drawnow;
end