function [] = showPressure3dPlot(myfilename)


[pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename);

% subsample the pressure like the robot software would
[pRaw_left_sub pRawTime_sub] = subsamplePressureVector(pRaw_left, pRawTime);
[pRaw_right_sub pRawTime_sub] = subsamplePressureVector(pRaw_right, pRawTime);
[pFilt_left_sub pFiltTime_sub] = subsamplePressureVector(pFilt_left, pFiltTime);
[pFilt_right_sub pFiltTime_sub] = subsamplePressureVector(pFilt_right, pFiltTime);

%tstart = 41*14; % 42 sampels per second * seconds to skip (why is this off?)
tstart = 1;

% copy over just the finger PAD data at this tiem step to a new vector
pad_left_zerod = pFilt_left_sub(tstart:end,8:22);
pad_right_zerod = pFilt_right_sub(tstart:end,8:22);

% left finger
% iterate over time samples (adjust how many we want to show here)
for i=1:length(pad_left_zerod(:,1))
    
    % first subplot
    subplot(1,2,1);
    
    % reshape this vector into a 5x3 matrix
    pad_left_zerod_matrix = reshape(pad_left_zerod(i,:), 3, 5);
    
    %plot it with blue bars
    bar3(pad_left_zerod_matrix,'b');
    
    %set the axes limits
    axis([0 5 0 5 -1000 5000]);
    
    title('Left Finger Pad');
    
    % second subplot
    subplot(1,2,2);    
    
    % reshape this vector into a 5x3 matrix
    pad_right_zerod_matrix = reshape(pad_right_zerod(i,:), 3, 5);
    
    %plot it with blue bars
    bar3(pad_right_zerod_matrix,'b');
    
    %set the axes limits
    axis([0 5 0 5 -1000 5000]);
    
    title('Right Finger Pad');    
    
    %force matlab to draw
    drawnow;
end



