function [] = showPressure3dPlotwGaussBlur(myfilename)



[pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename);

% subsample the pressure like the robot software would
[pRaw_left_sub pRawTime_sub] = subsamplePressureVector(pRaw_left, pRawTime);
[pRaw_right_sub pRawTime_sub] = subsamplePressureVector(pRaw_right, pRawTime);
[pFilt_left_sub pFiltTime_sub] = subsamplePressureVector(pFilt_left, pFiltTime);
[pFilt_right_sub pFiltTime_sub] = subsamplePressureVector(pFilt_right, pFiltTime);






% copy over just the finger PAD data at this tiem step to a new vector
pad_left_zerod = pFilt_left_sub(:,8:22);
pad_right_zerod = pFilt_right_sub(:,8:22);


% create a gaussian blur matrix
gaussBlur = fspecial('gaussian',5,0.88);

% left finger
% iterate over time samples
for i=1:length(pad_left_zerod(:,1))
    
    % first subplot
    subplot(1,2,1);
    
    % reshape this vector into a 5x3 matrix
    pad_left_matrix = reshape(pad_left_zerod(i,:), 3, 5);
    
    pad_left_matrix_blur = conv2(gaussBlur, pad_left_matrix);
    
    %plot it with blue bars
    bar3(pad_left_matrix_blur,'b');
    
    %set the axes limits
    zlim([-1000 5000]);
    XL = xlim;
    YL = ylim;
    
    title('Left Finger Pad');
    
    % second subplot
    subplot(1,2,2);    
    
    % reshape this vector into a 5x3 matrix
    pad_left_matrix = reshape(pad_left_zerod(i,:), 3, 5);
    
    %plot it with blue bars
    bar3(pad_left_matrix,'b');
    
    %set the axes limits
    axis([XL YL -1000 5000]);
    
    title('Left Finger Pad');    
    
    %force matlab to draw
    drawnow;
    
    % brief pause
    pause(0.02);
end




