function [] = showPressureCentroidPlot(myfilename)


[pRaw_left pRaw_right pRawTime pFilt_left pFilt_right pFiltTime acc_combined accTime joint_pos joint_vel joint_effort joint_time ] = loadAllRTP(myfilename);

% subsample the pressure like the robot software would
[pRaw_left_sub pRawTime_sub] = subsamplePressureVector(pRaw_left, pRawTime);
[pRaw_right_sub pRawTime_sub] = subsamplePressureVector(pRaw_right, pRawTime);
[pFilt_left_sub pFiltTime_sub] = subsamplePressureVector(pFilt_left, pFiltTime);
[pFilt_right_sub pFiltTime_sub] = subsamplePressureVector(pFilt_right, pFiltTime);






% copy over just the finger PAD data at this tiem step to a new vector
pad_left_zerod = pFilt_left_sub(:,8:22);
pad_right_zerod = pFilt_right_sub(:,8:22);

% left finger
% iterate over time samples (adjust how many we want to show here - every 40th is 25 hz)
for i=1:1:length(pad_left_zerod(:,1))
    
    % first subplot
    subplot(1,2,1);
    
    % reshape this vector into a 5x3 matrix
    pad_left_zerod_matrix = reshape(pad_left_zerod(i,:), 3, 5);
    
    % calculate the center of mass
    [xl yl ]= getMatrixCOM(pad_left_zerod_matrix);
    
    %plot it in 3d
    plot3([xl,xl],[yl,yl],[0,sum(sum(pad_left_zerod_matrix))],'LineWidth',8);
    grid on;
    
    %set the axes limits
    axis([-2 2 -2 2 0 10000]);
    set(gca,'DataAspectRatio',[1 1 1000]);   
    
    title('Left Finger Pad');
    
    % second subplot
    subplot(1,2,2);    
    
    % reshape this vector into a 5x3 matrix
    pad_right_zerod_matrix = reshape(pad_right_zerod(i,:), 3, 5);
    
    % calculate the center of mass
    [xr yr ]= getMatrixCOM(pad_right_zerod_matrix);
    
    %plot it in 3d
    plot3([xr,xr],[yr,yr],[0,sum(sum(pad_right_zerod_matrix))],'LineWidth',8);
    grid on;
    
    %set the axes limits
    axis([-2 2 -2 2 0 10000]);
    set(gca,'DataAspectRatio',[1 1 1000]);
    
    title('Right Finger Pad');    
    
    %force matlab to draw
    drawnow;
    
    % brief pause
    pause(0.05);
end



