"""autogenerated by genmsg_py from GripperFindContactGoal.msg. Do not edit."""
import roslib.message
import struct

import slipgrip_controller.msg

class GripperFindContactGoal(roslib.message.Message):
  _md5sum = "bfe6b7c04bfbb7b616c308b805ecc4a9"
  _type = "slipgrip_controller/GripperFindContactGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Contact action used to close fingers and find object contacts

#goal
GripperFindContactCommand command

================================================================================
MSG: slipgrip_controller/GripperFindContactCommand
# Contact action used to close fingers and find object contacts

# true if you want to zero out the force at the beginning of the
# find contact algorithm.
# NOTE: SHOULD ONLY BE TRUE WHEN BOTH FINGERS ARE TOUCHING NOTHING
bool zero_forces

# the finger contact conditions that determine what our goal is
# 0 = both fingers impact
# 1 = left finger impact
# 2 = right finger impact
# 3 = either finger impact
int16 contacts_desired

# speed to close the gripper in m/s
# values <0 result in default speed
float64 close_speed

# the maximum motor effort level (N) to use
# useful for safety purposes if object does not make contact at fingerpads
# value <0 rseult in unlimited effort
float64 max_effort

# control mode to enter after contact
# true means force control mode using contact force
# false means position control mode using contact position
bool force_control_at_goal
"""
  __slots__ = ['command']
  _slot_types = ['slipgrip_controller/GripperFindContactCommand']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       command
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperFindContactGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.command is None:
        self.command = slipgrip_controller.msg.GripperFindContactCommand()
    else:
      self.command = slipgrip_controller.msg.GripperFindContactCommand()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_Bh2dB.pack(_x.command.zero_forces, _x.command.contacts_desired, _x.command.close_speed, _x.command.max_effort, _x.command.force_control_at_goal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.command is None:
        self.command = slipgrip_controller.msg.GripperFindContactCommand()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.command.zero_forces, _x.command.contacts_desired, _x.command.close_speed, _x.command.max_effort, _x.command.force_control_at_goal,) = _struct_Bh2dB.unpack(str[start:end])
      self.command.zero_forces = bool(self.command.zero_forces)
      self.command.force_control_at_goal = bool(self.command.force_control_at_goal)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_Bh2dB.pack(_x.command.zero_forces, _x.command.contacts_desired, _x.command.close_speed, _x.command.max_effort, _x.command.force_control_at_goal))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.command is None:
        self.command = slipgrip_controller.msg.GripperFindContactCommand()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.command.zero_forces, _x.command.contacts_desired, _x.command.close_speed, _x.command.max_effort, _x.command.force_control_at_goal,) = _struct_Bh2dB.unpack(str[start:end])
      self.command.zero_forces = bool(self.command.zero_forces)
      self.command.force_control_at_goal = bool(self.command.force_control_at_goal)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_Bh2dB = struct.Struct("<Bh2dB")
