"""autogenerated by genmsg_py from GripperPlaceData.msg. Do not edit."""
import roslib.message
import struct

import roslib.msg

class GripperPlaceData(roslib.message.Message):
  _md5sum = "467621d7be9b0ed1b2a363dfd7f6dd0e"
  _type = "slipgrip_controller/GripperPlaceData"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# standard header information
Header header

# the currently applied motor effort of the gripper
float64 motor_effort

# the currently experienced fingerpad grip force
float64 fingerpad_force

# true if the object has been placed down
bool placed

# true if the pressure sensors detected contact via slip processing
bool slipContact

# true if the hand-mounted accelerometer detected a contact acceleration
bool accelerationContact

# the state of our realtime controller
int16 realtime_controller_state
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','motor_effort','fingerpad_force','placed','slipContact','accelerationContact','realtime_controller_state']
  _slot_types = ['Header','float64','float64','bool','bool','bool','int16']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,motor_effort,fingerpad_force,placed,slipContact,accelerationContact,realtime_controller_state
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperPlaceData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.motor_effort is None:
        self.motor_effort = 0.
      if self.fingerpad_force is None:
        self.fingerpad_force = 0.
      if self.placed is None:
        self.placed = False
      if self.slipContact is None:
        self.slipContact = False
      if self.accelerationContact is None:
        self.accelerationContact = False
      if self.realtime_controller_state is None:
        self.realtime_controller_state = 0
    else:
      self.header = roslib.msg._Header.Header()
      self.motor_effort = 0.
      self.fingerpad_force = 0.
      self.placed = False
      self.slipContact = False
      self.accelerationContact = False
      self.realtime_controller_state = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3Bh.pack(_x.motor_effort, _x.fingerpad_force, _x.placed, _x.slipContact, _x.accelerationContact, _x.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.motor_effort, _x.fingerpad_force, _x.placed, _x.slipContact, _x.accelerationContact, _x.realtime_controller_state,) = _struct_2d3Bh.unpack(str[start:end])
      self.placed = bool(self.placed)
      self.slipContact = bool(self.slipContact)
      self.accelerationContact = bool(self.accelerationContact)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3Bh.pack(_x.motor_effort, _x.fingerpad_force, _x.placed, _x.slipContact, _x.accelerationContact, _x.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.motor_effort, _x.fingerpad_force, _x.placed, _x.slipContact, _x.accelerationContact, _x.realtime_controller_state,) = _struct_2d3Bh.unpack(str[start:end])
      self.placed = bool(self.placed)
      self.slipContact = bool(self.slipContact)
      self.accelerationContact = bool(self.accelerationContact)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2d3Bh = struct.Struct("<2d3Bh")
