"""autogenerated by genmsg_py from GripperPlaceFeedback.msg. Do not edit."""
import roslib.message
import struct

import slipgrip_controller.msg
import roslib.msg

class GripperPlaceFeedback(roslib.message.Message):
  _md5sum = "e97782d051de5711e3972eba799e4888"
  _type = "slipgrip_controller/GripperPlaceFeedback"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# feedback
GripperPlaceData data



================================================================================
MSG: slipgrip_controller/GripperPlaceData
# standard header information
Header header

# the currently applied motor effort of the gripper
float64 motor_effort

# the currently experienced fingerpad grip force
float64 fingerpad_force

# true if the object has been placed down
bool placed

# true if the pressure sensors detected contact via slip processing
bool slipContact

# true if the hand-mounted accelerometer detected a contact acceleration
bool accelerationContact

# the state of our realtime controller
int16 realtime_controller_state
================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['data']
  _slot_types = ['slipgrip_controller/GripperPlaceData']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       data
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperPlaceFeedback, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperPlaceData()
    else:
      self.data = slipgrip_controller.msg.GripperPlaceData()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs))
      _x = self.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3Bh.pack(_x.data.motor_effort, _x.data.fingerpad_force, _x.data.placed, _x.data.slipContact, _x.data.accelerationContact, _x.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperPlaceData()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.data.motor_effort, _x.data.fingerpad_force, _x.data.placed, _x.data.slipContact, _x.data.accelerationContact, _x.data.realtime_controller_state,) = _struct_2d3Bh.unpack(str[start:end])
      self.data.placed = bool(self.data.placed)
      self.data.slipContact = bool(self.data.slipContact)
      self.data.accelerationContact = bool(self.data.accelerationContact)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs))
      _x = self.data.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3Bh.pack(_x.data.motor_effort, _x.data.fingerpad_force, _x.data.placed, _x.data.slipContact, _x.data.accelerationContact, _x.data.realtime_controller_state))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.data is None:
        self.data = slipgrip_controller.msg.GripperPlaceData()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.data.header.seq, _x.data.header.stamp.secs, _x.data.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.data.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 21
      (_x.data.motor_effort, _x.data.fingerpad_force, _x.data.placed, _x.data.slipContact, _x.data.accelerationContact, _x.data.realtime_controller_state,) = _struct_2d3Bh.unpack(str[start:end])
      self.data.placed = bool(self.data.placed)
      self.data.slipContact = bool(self.data.slipContact)
      self.data.accelerationContact = bool(self.data.accelerationContact)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2d3Bh = struct.Struct("<2d3Bh")
