"""autogenerated by genmsg_py from GripperSlipServoCommand.msg. Do not edit."""
import roslib.message
import struct


class GripperSlipServoCommand(roslib.message.Message):
  _md5sum = "e90cb308a5a9dc077a44646cafc1027d"
  _type = "slipgrip_controller/GripperSlipServoCommand"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# command to send to SlipServo action

# the maximum allowed object deformation (in meters) measured from the starting position of the action call
# a deformation value < 0 results in unlimited deformation
float64 deformation_limit

# the fingertip force (in Newtons) to start the slipServoing method at.
# a force value < 0 results in using the default value of the currently applied force
# note that this is the average grip force (average of left and right fingertip forces)
float64 fingertip_start_force

# the maximum amount of fingertip force (in Newtons) to apply.
# values < 0 indicate no limit on the fingertip force applied
float64 fingertip_force_limit

# the maximum amount of joint effort to allow (in Newtons)
# values < 0 indicate no limit on the motor effort appliedd
# NOTE: This is useful as a safety precaution in case the object does not contact
# the pressure sensors on the fingerpad
float64 max_effort


"""
  __slots__ = ['deformation_limit','fingertip_start_force','fingertip_force_limit','max_effort']
  _slot_types = ['float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       deformation_limit,fingertip_start_force,fingertip_force_limit,max_effort
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperSlipServoCommand, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.deformation_limit is None:
        self.deformation_limit = 0.
      if self.fingertip_start_force is None:
        self.fingertip_start_force = 0.
      if self.fingertip_force_limit is None:
        self.fingertip_force_limit = 0.
      if self.max_effort is None:
        self.max_effort = 0.
    else:
      self.deformation_limit = 0.
      self.fingertip_start_force = 0.
      self.fingertip_force_limit = 0.
      self.max_effort = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_4d.pack(_x.deformation_limit, _x.fingertip_start_force, _x.fingertip_force_limit, _x.max_effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      _x = self
      start = end
      end += 32
      (_x.deformation_limit, _x.fingertip_start_force, _x.fingertip_force_limit, _x.max_effort,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_4d.pack(_x.deformation_limit, _x.fingertip_start_force, _x.fingertip_force_limit, _x.max_effort))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 32
      (_x.deformation_limit, _x.fingertip_start_force, _x.fingertip_force_limit, _x.max_effort,) = _struct_4d.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_4d = struct.Struct("<4d")
